Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | List of all members
Botan::Chain Class Referencefinal

`#include <filters.h>`

Inheritance diagram for Botan::Chain:

## Public Member Functions
virtual bool | attachable ()
| Chain (Filter *=nullptr, Filter *=nullptr, Filter *=nullptr, Filter *=nullptr)
| Chain (Filter *filter_arr[], size_t length)
virtual void | end_msg ()
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t input[], size_t length) override

## Protected Member Functions
void | attach (Filter *f)
void | incr_owns ()
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in)
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in, size_t length)
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | set_next (Filter *f[], size_t n)
void | set_port (size_t n)

## Detailed Description

This class represents Filter chains. A Filter chain is an ordered concatenation of Filters, the input to a Chain sequentially passes through all the Filters contained in the Chain.

Definition at line 654 of file filters.h.

## Constructor & Destructor Documentation

## ◆ Chain() [1/2]

Botan::Chain::Chain | ( | Filter * | f1 = `nullptr`,
|  | Filter * | f2 = `nullptr`,
|  | Filter * | f3 = `nullptr`,
|  | Filter * | f4 = `nullptr`
| ) |  |

Construct a chain of up to four filters. The filters are set up in the same order as the arguments.

Definition at line 14 of file basefilt.cpp.

15 {
16 if(f1) { attach(f1); incr_owns(); }
17 if(f2) { attach(f2); incr_owns(); }
18 if(f3) { attach(f3); incr_owns(); }
19 if(f4) { attach(f4); incr_owns(); }
20 }
Botan::Fanout_Filter::incr_owns
void incr_owns()
Definition: filter.h:150
Botan::Fanout_Filter::attach
void attach(Filter *f)
Definition: filter.h:156

References Botan::Fanout_Filter::attach(), and Botan::Fanout_Filter::incr_owns().

## ◆ Chain() [2/2]

Botan::Chain::Chain | ( | Filter * | filter_arr[],
|  | size_t | length
| ) |  |

Construct a chain from range of filters

Parameters

  filter_arr | the list of filters
  length | how many filters

Definition at line 25 of file basefilt.cpp.

26 {
27 for(size_t j = 0; j != count; ++j)
28 if(filters[j])
29 {
30 attach(filters[j]);
31 incr_owns();
32 }
33 }

References Botan::Fanout_Filter::attach(), and Botan::Fanout_Filter::incr_owns().

## Member Function Documentation

## ◆ attach()

void Botan::Fanout_Filter::attach | ( | Filter * | f | ) |
| inline protected inherited

Definition at line 156 of file filter.h.

156{ Filter::attach(f); }

Referenced by Chain().

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::DataSink, and Botan::SecureQueue.

Definition at line 52 of file filter.h.

52{ return true; }

## ◆ end_msg()

virtual void Botan::Filter::end_msg | ( |  | ) |
| inline virtual inherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::DataSink_Stream, Botan::Base64_Encoder, Botan::Base64_Decoder, Botan::Hex_Encoder, and Botan::Hex_Decoder.

Definition at line 46 of file filter.h.

46{ /* default empty */ }

## ◆ incr_owns()

void Botan::Fanout_Filter::incr_owns | ( |  | ) |
| inline protected inherited

Increment the number of filters past us that we own

Definition at line 150 of file filter.h.

150{ ++m_filter_owns; }

Referenced by Chain().

## ◆ name()

std::string Botan::Chain::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 659 of file filters.h.

659{ return "Chain"; }

## ◆ send() [1/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 71 of file filter.h.

72 {
73 send(in.data(), in.size());
74 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

## ◆ send() [2/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 BOTAN_ASSERT_NOMSG(length <= in.size());
84 send(in.data(), length);
85 }
BOTAN_ASSERT_NOMSG
#define BOTAN_ASSERT_NOMSG(expr)
Definition: assert.h:68

References BOTAN_ASSERT_NOMSG.

## ◆ send() [3/4]

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

References Botan::Filter::write().

Referenced by Botan::Base64_Encoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::write(), and Botan::Hex_Decoder::write().

## ◆ send() [4/4]

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

65{ send(&in, 1); }

References Botan::Filter::send().

Referenced by Botan::Filter::send().

## ◆ set_next()

void Botan::Fanout_Filter::set_next | ( | Filter * | f[],
|  | size_t | n
| ) |  |
| inline protected inherited

Definition at line 154 of file filter.h.

154{ Filter::set_next(f, n); }

Referenced by Botan::Fork::Fork(), and Botan::SecureQueue::SecureQueue().

## ◆ set_port()

void Botan::Fanout_Filter::set_port | ( | size_t | n | ) |
| inline protected inherited

Definition at line 152 of file filter.h.

152{ Filter::set_port(n); }

Referenced by Botan::Fork::set_port().

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40{ /* default empty */ }

## ◆ write()

void Botan::Chain::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| inline override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 657 of file filters.h.

657{ send(input, length); }

The documentation for this class was generated from the following files:

- src/lib/filters/filters.h
- src/lib/filters/basefilt.cpp